﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection.PortableExecutable;
using System.Text;
using System.Threading.Tasks;

namespace AntiAircraftGun
{
    internal class DrawingObjectAntiAircraftGun : IDrawingObject
    {
        private DrawingAntiAircraftGun _antiAircraftGun = null;
        public DrawingObjectAntiAircraftGun(DrawingAntiAircraftGun antiAircraftGun)
        {
            _antiAircraftGun = antiAircraftGun;
        }
        public float Step => _antiAircraftGun?.AntiAircraftGun?.Step ?? 0;
        public DrawingAntiAircraftGun GetAntiAircraftGun => _antiAircraftGun;
        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _antiAircraftGun?.GetCurrentPosition() ?? default;
        }

        public void MoveObject(Direction direction)
        {
            _antiAircraftGun?.MoveTransport(direction);
        }
        public void SetObject(int x, int y, int width, int height)
        {
            _antiAircraftGun.SetPosition(x, y, width, height);
        }

        void IDrawingObject.DrawingObjectAntiAircraftGun(Graphics g)
        {
            _antiAircraftGun?.DrawTransport(g);
        }

        public string GetInfo() => _antiAircraftGun?.GetDataForSave();
        public static IDrawingObject Create(string data) => new DrawingObjectAntiAircraftGun(data.CreateDrawingAntiAircraftGun());

        public bool Equals(IDrawingObject? other)
        {
            if (other == null)
            {
                return false;
            }
            var otherAntiAircraftGun = other as DrawingObjectAntiAircraftGun;
            if (otherAntiAircraftGun == null)
            {
                return false;
            }
            var antiAircraftGun = _antiAircraftGun.AntiAircraftGun;
            var otherAntiAircraftGunAntiAircraftGun = otherAntiAircraftGun._antiAircraftGun.AntiAircraftGun;
            if (antiAircraftGun.Speed != otherAntiAircraftGunAntiAircraftGun.Speed)
            {
                return false;
            }
            if (antiAircraftGun.Weight != otherAntiAircraftGunAntiAircraftGun.Weight)
            {
                return false;
            }
            if (antiAircraftGun.BodyColor != otherAntiAircraftGunAntiAircraftGun.BodyColor)
            {
                return false;
            }

            if (antiAircraftGun is EntityUpdateAntiAircraftGun && otherAntiAircraftGunAntiAircraftGun is EntityUpdateAntiAircraftGun)
            {
                var updateAntiAircraftGun = antiAircraftGun as EntityUpdateAntiAircraftGun;
                var otherUpdateAntiAircraftGun = otherAntiAircraftGunAntiAircraftGun as EntityUpdateAntiAircraftGun;
                if (updateAntiAircraftGun.DopColor != otherUpdateAntiAircraftGun.DopColor || updateAntiAircraftGun.Gun != otherUpdateAntiAircraftGun.Gun ||
                    updateAntiAircraftGun.Radar != otherUpdateAntiAircraftGun.Radar)
                {
                    return false;
                }
            }
            else if (antiAircraftGun is EntityUpdateAntiAircraftGun || otherAntiAircraftGunAntiAircraftGun is EntityUpdateAntiAircraftGun)
            {
                return false;
            }

            return true;
        }
    }
}
