﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AntiAircraftGun
{
    internal class EntityUpdateAntiAircraftGun : EntityAntiAircraftGun
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; set; }
        /// <summary>
        /// Признак наличия башни с орудием
        /// </summary>
        public bool Gun { get; private set; }
        /// <summary>
        /// Признак наличия радара
        /// </summary>
        public bool Radar { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес зенитного орудия</param>
        /// <param name="bodyColor">Цвет корпуса</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="gun">Признак наличия башни с орудием</param>
        /// <param name="radar">Признак наличия радара</param>
        public EntityUpdateAntiAircraftGun(int speed, float weight, Color bodyColor, Color dopColor, bool gun, bool radar) :
        base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            Gun = gun;
            Radar = radar;
        }
    }
}
