using System.Windows.Forms;

namespace AntiAircraftGun
{
    public partial class FormAntiAircraftGun : Form
    {
        private DrawingAntiAircraftGun _antiAircrafGun;
        /// <summary>
        ///  
        /// </summary>
        public DrawingAntiAircraftGun SelectedAntiAircraftGun { get; private set; }

        public FormAntiAircraftGun()
        {
            InitializeComponent();
        }
        /// <summary>
        ///    
        /// </summary>
        private void Draw()
        {
            if (pictureBoxAntiAircraftGun.Width > 0 && pictureBoxAntiAircraftGun.Height > 0)
            {
                Bitmap bmp = new(pictureBoxAntiAircraftGun.Width, pictureBoxAntiAircraftGun.Height);
                Graphics gr = Graphics.FromImage(bmp);
                _antiAircrafGun?.DrawTransport(gr);
                pictureBoxAntiAircraftGun.Image = bmp;
            }
        }
        /// <summary>
        ///   
        /// </summary>
        private void SetData()
        {
            Random rnd = new();
            _antiAircrafGun.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxAntiAircraftGun.Width, pictureBoxAntiAircraftGun.Height);
            toolStripStatusLabelSpeed.Text = $": {_antiAircrafGun.AntiAircraftGun.Speed}";
            toolStripStatusLabelWeight.Text = $": {_antiAircrafGun.AntiAircraftGun.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_antiAircrafGun.AntiAircraftGun.BodyColor.Name}";
        }

        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _antiAircrafGun = new DrawingAntiAircraftGun(rnd.Next(100, 300), rnd.Next(1000, 2000), color);
            SetData();
            Draw();
        }
        /// <summary>
        ///  
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _antiAircrafGun?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _antiAircrafGun?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _antiAircrafGun?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _antiAircrafGun?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxAntiAircraftGun_Resize(object sender, EventArgs e)
        {
            _antiAircrafGun?.ChangeBorders(pictureBoxAntiAircraftGun.Width, pictureBoxAntiAircraftGun.Height);
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreareModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _antiAircrafGun = new DrawingUpdateAntiAircraftGun(rnd.Next(100, 300), rnd.Next(1000, 2000), color, dopColor,
            Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }

        private void ButtonSelect_Click(object sender, EventArgs e)
        {
            SelectedAntiAircraftGun = _antiAircrafGun;
            DialogResult = DialogResult.OK;
        }
    }
}